package ethz.ch.pp.mergeSort;

import ethz.ch.pp.util.RandomGenerator;

public class Main {

	public static void main(String[] args) {
	    RandomGenerator dg = new RandomGenerator();
	    int[] input = dg.randomArray(1024*1024*5);
	    
	    taskA(input);
	    taskB(input, 2);
	    
	    taskA(input);
	    taskB(input, 1);
	    taskB(input, 2);
	    taskB(input, 3);
	    taskB(input, 4);
	    taskB(input, 5);
	    taskB(input, 6);
	    taskB(input, 7);
	    taskB(input, 8);
	    
	    taskB(input, Runtime.getRuntime().availableProcessors());
	    
	    taskA(input);
	    taskBOpt(input, 1);
	    taskBOpt(input, 2);
	    taskBOpt(input, 3);
	    taskBOpt(input, 4);
	    taskBOpt(input, 5);
	    taskBOpt(input, 6);
	    taskBOpt(input, 7);
	    taskBOpt(input, 8);
	    
	    taskBOpt(input, Runtime.getRuntime().availableProcessors());
	}
	
	public static void taskA(int[] input){
		long t0 = System.currentTimeMillis();
		for (int i = 0; i < 5; i++) {
			MergeSortSingle.sort(input);
		}
		long t1 = System.currentTimeMillis();
		System.out.println("For (inputsize=" + input.length + ") MergeSort Single takes " + ((t1 - t0)/5) + " msec");
		
	}
	
	public static void taskB(int[] input, int numThreads){
		long t0 = System.currentTimeMillis();
		for (int i = 0; i < 5; i++) {
			MergeSortMulti.sort(input, numThreads);
		}
		long t1 = System.currentTimeMillis();
		System.out.println("For (inputsize=" + input.length + ") MergeSort Multi with " + numThreads + " threads takes " + ((t1 - t0)/5) + " msec");
	}
	
	public static void taskBOpt(int[] input, int numThreads){
		long t0 = System.currentTimeMillis();
		for (int i = 0; i < 5; i++) {
			MergeSortMultiOpt.sort(input, numThreads);
		}
		long t1 = System.currentTimeMillis();
		System.out.println("For (inputsize=" + input.length + ") MergeSort Multi (Optimized) with " + numThreads + " threads takes " + ((t1 - t0)/5) + " msec");
	}

}

