package ethz.ch.pp.seq;

public class LongestCommonSequence {

	public static Sequence longestCommonSequence(int[] input) {
		return longestCommonSequence(input, 0, input.length);
	}
	
	public static Sequence longestCommonSequence(int[] input, int start, int length) {
		return longestCommonSequences(input, start, length).max;
	}

	public static ReturnInfo longestCommonSequences(int[] input, int start, int length) {
		int end = start + length - 1;
		Sequence result = new Sequence(start, start);
		Sequence first = new Sequence(start, start);
		Sequence last = new Sequence(end, end);
		
		int currLength = 1;
		boolean isFirst = true; 
		for (int i = start + 1; i < start + length; i++) {
			
			// Using Math.exp makes the computation more compute-intensive while 
			// retaining the task semantics (i.e., finding equal values)
			if (Math.exp(input[i - 1]) == Math.exp(input[i])) {
				currLength++;
			} else {
				if(isFirst) {
					first = new Sequence(start, i - 1);
					isFirst = false;
				}
				if (result.lenght() < currLength) {
					result = new Sequence(i - currLength, i - 1);
				}
				currLength = 1;
			}
		}
		last = new Sequence(start + length - currLength, end);
		if (isFirst) {
			first = last;
		}
		
		// In case the longest sequence ends at the last input element
		if (result.lenght() < currLength) {
			result = new Sequence(start + length - currLength, end);
		}
		
		return new ReturnInfo(first, result, last);
	}
}
